//Top level of the example design in Verilog
module top ( SRAM_DATA,  RD_addr, WR_EN, RD_EN, Aclr,WR_addr,
             WClock, RClock);

inout [7:0] SRAM_DATA;
input [6:0] WR_addr;
output [6:0] RD_addr;
input WR_EN, RD_EN, Aclr, WClock, RClock;

reg [7:0] SRAM_DATA_out;
reg DIR_CON;
reg [7:0] WDATA;
wire [7:0] RDATA; 
reg [6:0] RADDR;

always @ (WR_EN or RD_EN)
begin
if (WR_EN == 0) 
  DIR_CON <= 0;
else if (RD_EN == 0) 
  DIR_CON <= 1;
else
  DIR_CON <= 0;
end

always @ ( posedge WClock)
begin
 if (DIR_CON == 0)
   WDATA <= SRAM_DATA;
end

always @ ( posedge RClock)
begin 
  if (DIR_CON == 1) 
     SRAM_DATA_out <= RDATA;
   else
    SRAM_DATA_out <= 8'bzzzzzzzz; 
    
end

always @  (posedge RClock or negedge Aclr)
begin 
if (Aclr == 0) 
  RADDR <= 7'b0000000;
else 
  begin
  
       if (RD_EN == 0) 
       RADDR <= RADDR + 1;
  end
  
end

memory U1 (.Data(WDATA),.Q(RDATA),.WAddress(WR_addr),.RAddress(RD_addr),
           .WE(WR_EN),.RE(RD_EN),.WClock(WClock),.RClock(RClock));
assign SRAM_DATA = SRAM_DATA_out;

assign RD_addr = RADDR;

endmodule
